#	include	"Simulator.h"


bool
Loader	::	DumpHeader (
	struct	ecoff_filehdr	*fh)
	{
	printf("filehdr->f_magic = 0x%x\n", fh->f_magic);
	printf("filehdr->f_nscns = %d\n", fh->f_nscns);
	printf("filehdr->f_timedat = %d\n", fh->f_timdat);
	printf("filehdr->f_symptr = %d\n", fh->f_symptr);
	printf("filehdr->f_nsyms = %d\n", fh->f_nsyms);
	printf("filehdr->f_opthdr = %u\n", fh->f_opthdr);
	printf("filehdr->f_flags = %u\n", fh->f_flags);
	return ( true );
	}

bool
Loader	::	DumpHeader (
	struct	ecoff_aouthdr	*ah)
	{
	printf("aouthdr->magic = %d\n", ah->magic);
	printf("aouthdr->vstamp = %d\n", ah->vstamp);
	printf("aouthdr->tsize = %d\n", ah->tsize);
	printf("aouthdr->dsize = %d\n", ah->dsize);
	printf("aouthdr->entry = 0x%x\n", ah->entry);
	printf("aouthdr->text_start = 0x%x\n", ah->text_start);
	printf("aouthdr->data_start = 0x%x\n", ah->data_start);
	printf("aouthdr->bss_start = 0x%x\n", ah->bss_start);
	printf("aouthdr->gprmask = %d\n", ah->gprmask);
	printf("aouthdr->cprmask[0] = %d\n", ah->cprmask[0]);
	printf("aouthdr->cprmask[1] = %d\n", ah->cprmask[1]);
	printf("aouthdr->cprmask[2] = %d\n", ah->cprmask[2]);
	printf("aouthdr->cprmask[3] = %d\n", ah->cprmask[3]);
	printf("aouthdr->gp_value = 0x%x\n", ah->gp_value);
	return ( true );
	}

bool
Loader	::	DumpHeader (
	struct	ecoff_scnhdr	*sh)
	{
	printf("scnhdr->s_name = %s\n", sh->s_name);
	printf("scnhdr->s_paddr = 0x%x\n", sh->s_paddr);
	printf("scnhdr->s_vaddr = 0x%x\n", sh->s_vaddr);
	printf("scnhdr->s_size = %d\n", sh->s_size);
	printf("scnhdr->s_scnptr = %d\n", sh->s_scnptr);
	printf("scnhdr->s_relptr = %d\n", sh->s_relptr);
	printf("scnhdr->s_lnnoptr = %d\n", sh->s_lnnoptr);
	printf("scnhdr->s_nreloc = %u\n", sh->s_nreloc);
	printf("scnhdr->s_nlnno = %u\n", sh->s_nlnno);
	printf("scnhdr->s_flags = %u\n", sh->s_flags);
	return ( true );
	}

bool
Loader	::	DumpHeader (
	ExecFile		*ef)
	{
	printf("** Dump ExecFile Header\n");
	printf("-->struct ecoff_filehdr FileHeader\n");
	DumpHeader(&ef->FileHeader);
	printf("-->struct ecoff_aouthdr aoutHeader\n");
	DumpHeader(&ef->aoutHeader);
	printf("-->struct ecoff_scnhdr textHeader\n");
	DumpHeader(&ef->textHeader);
	printf("-->struct ecoff_scnhdr rdataHeader\n");
	DumpHeader(&ef->rdataHeader);
	printf("-->struct ecoff_scnhdr dataHeader\n");
	DumpHeader(&ef->dataHeader);
	printf("-->struct ecoff_scnhdr sdataHeader\n");
	DumpHeader(&ef->sdataHeader);
	printf("-->struct ecoff_scnhdr sbssHeader\n");
	DumpHeader(&ef->sbssHeader);
	printf("-->struct ecoff_scnhdr bssHeader\n");
	DumpHeader(&ef->bssHeader);

	return ( false );
	}

bool
Loader	::	LoadSegmentIntoMemorySystem(
	int							fd,
	ExecFile					*ef,
	struct		ecoff_scnhdr	*Section,
	MemorySystem				*ms)
	{

	if(!Section->s_scnptr)
		{
		return(true);
		}

	lseek(fd, Section->s_scnptr, SEEK_SET);

	byte	*Data = new uint8[Section->s_size];

	if(read(fd, Data, Section->s_size)!=Section->s_size)
		{
		printf("error loading section of file\n");
		delete Data;
		return(false);
		}
	if(ms->CopyFromHost(
		(void*)Section->s_vaddr,
		(void*)Data,
		Section->s_size))
		{
		delete Data;
		return(true);
		}
	printf("Error writing into core\n");
	delete Data;
	return(false);
	}


#	define	FIS_Update	\
	bOutput = (uint8*)&Output[Size];	\
	uintOutput = (uint*)&Output[Size]

int
Loader	::	FormulateInitialStack (
	unsigned	int		StackBase,
	int					argc,
	char				*argv[],
	char				*argp[],
	unsigned			char	*Output)
	{
	uint		*uintOutput = (uint *)Output;
	uint8		*bOutput = (byte *)Output;
	int			Size		=	0;

	(*uintOutput) = (uint)argc;	Size += 4;	FIS_Update;
	int		ArgvSize = 0;
	int		ArgpSize = 0;
	while(argv[ArgvSize]) ++ArgvSize;
	while(argp[ArgpSize]) ++ArgpSize;

	uint	FirstString = StackBase + 4 + (ArgvSize+1 + ArgpSize+1)*4;
	uint	RunningString = FirstString;

	int		Index = 0;
	while(Index<ArgvSize)
		{
		(*uintOutput) = RunningString;
		Size += 4;
		RunningString += (strlen(argv[Index]) + 1);
		FIS_Update;
		++Index;
		}
	(*uintOutput) = 0;
	Size += 4;
	FIS_Update;
	Index = 0;
	while(Index<ArgpSize)
		{
		(*uintOutput) = RunningString;
		Size += 4;
		RunningString += (strlen(argp[Index]) + 1);
		FIS_Update;
		++Index;
		}
	(*uintOutput) = 0;
	Size += 4;
	FIS_Update;
	// Now, output the strings
	RunningString = FirstString;
	Index = 0;
	int	sIndex;
	while(Index<ArgvSize)
		{
		sIndex = 0;
		while(argv[Index][sIndex])
			{
			(*bOutput) = argv[Index][sIndex];
			++bOutput;
			++Size;
			++RunningString;
			++sIndex;
			}
		(*bOutput) = '\0';
		++bOutput;
		++Size;
		++RunningString;	
		++Index;
		}
	Index = 0;
	while(Index<ArgpSize)
		{
		sIndex = 0;
		while(argp[Index][sIndex])
			{
			(*bOutput) = argp[Index][sIndex];
			++bOutput;
			++Size;
			++RunningString;
			++sIndex;
			}
		(*bOutput) = '\0';
		++bOutput;
		++Size;
		++RunningString;
		++Index;
		}
	return(Size);
	}


bool
Loader	::	LoadFromDevice (
	int		fd,
	MemorySystem	*ms,
	Processor		*p,
	char			**argv,
	char			**argp)
	{
	ExecFile		ef;

	int		BytesRead = read(fd, &ef, sizeof(ExecFile));

	if(BytesRead != sizeof(ExecFile))
		{
		// Error Loading
		return ( NULL );
		}

	// First thing we do is allocate memory for everything.  Now,
	// there are 5 segments, but there are really three distinct pieces
	// of memory to allocate: code, data and stack.  We initially provide
	// only a single page of stack.  However, to calculate the amount
	// of code and data we use we need to look at the header.


	// Ok. now, this requires a "double copy" which isn't pretty, but
	// such is life.  We load each segment (6 of them) in turn into
	// the user space
	LoadSegmentIntoMemorySystem(fd, &ef, &ef.textHeader, ms);
	LoadSegmentIntoMemorySystem(fd, &ef, &ef.rdataHeader, ms);
	LoadSegmentIntoMemorySystem(fd, &ef, &ef.dataHeader, ms);
	LoadSegmentIntoMemorySystem(fd, &ef, &ef.sdataHeader, ms);
	LoadSegmentIntoMemorySystem(fd, &ef, &ef.sbssHeader, ms);
	LoadSegmentIntoMemorySystem(fd, &ef, &ef.bssHeader, ms);


	(*p->GetProgramCounter()) = ef.aoutHeader.entry;
	//theContext->regGPRS[28] = ef.aoutHeader.gp_value;
	//theContext->regGPRS[29] = theProcess->StackBase - 0x0800;
	p->GetIntegerRegisterSet()[29] = 0x7fff0000;

	unsigned	char	InitialStack[0x1000];

	char		*t_argv[]	=	{
		"arg0", "arg1", "arg2"	};
	char		*t_argp[]	=	{
		"TERM=vt100", "user=noone"	};

	char		**a_argv, **a_argp;

	if(argv==NULL)
		a_argv = t_argv;
	else
		a_argv = argv;
	if(argp == NULL)
		a_argp = t_argp;
	else
		a_argp = argp;

	int			argc = 0;
	while(a_argv[argc])
		++argc;	

	int	InitialStackSize = FormulateInitialStack(
		p->GetIntegerRegisterSet()[29], argc, a_argv, a_argp, InitialStack);


	ms->CopyFromHost(
		(void*)(p->GetIntegerRegisterSet()[29]),
		InitialStack,
		InitialStackSize);

	return ( true );
	}


bool
Loader	::	LoadFromDevice (
	char			*Filename,
	MemorySystem	*ms,
	Processor		*p,
	char			**argv,
	char			**argp)
	{
	FILE	*fp = fopen(Filename, "rb");
	if(!fp)
		{
		printf("Error reading input file: %s\n", Filename);
		return ( false );
		}

	bool	Ret = LoadFromDevice(fileno(fp), ms, p, argv, argp);
	fclose(fp);
	if(!Ret)
		{
		printf("Could not load file!\n");
		}
	return ( Ret );
	}

