#	include	"Simulator.h"


// Here are some base-class support functions for all memory systems.
// it might prove helpful to re-do these functions for a particular
// type of memory system, because then you can optimize them.  But
// you don't have to..

bool
MemorySystem	::	CopyFromHost (
	void	*Destination,
	void	*Source,
	int		Bytes)
	{
	uint8	*BytePtr = (uint8*)Source;
	uint32	*WordPtr = (uint32*)Source;
	uint32	*dDestination = (uint32*) Destination;
	uint8	*bDestination = (uint8*) Destination;

	while(Bytes>=4)
		{
		WriteMemory32((SimAddress)dDestination, (uint32)*WordPtr);
		++WordPtr;
		++dDestination;
		bDestination += 4;
		BytePtr += 4;
		Bytes -= 4;
		}
		
	while(Bytes)
		{
		WriteMemory8((SimAddress)bDestination, (uint8)*BytePtr);
		--Bytes;
		++BytePtr;
		++bDestination;
		}
	return ( true );
	}

bool
MemorySystem	::	CopyToHost (
	void	*Destination,
	void	*Source,
	int		Bytes)
	{
	uint8	*BytePtr = (uint8*)Source;
	uint32	*WordPtr = (uint32*)Source;
	uint8	*dBytePtr = (uint8*)Destination;
	uint32	*dWordPtr = (uint32*)Destination;
	uint32	Word;
	uint8	Byte;

	while(Bytes>=4)
		{
		Word = ReadMemory32((SimAddress)WordPtr);
		(*dWordPtr) = Word;
		++WordPtr;++dWordPtr;
		BytePtr += 4;dBytePtr += 4;
		Bytes -= 4;
		}
		
	while(Bytes)
		{
		Byte = ReadMemory8((SimAddress)BytePtr);
		(*dBytePtr) = Byte;
		++dBytePtr;
		++BytePtr;
		--Bytes;
		}
	return ( true );
	}


bool
MemorySystem	::	CopyStringFromHost(
	void	*Destination,
	void	*Source,
	int		MaxBytes)
	{
	uint8	*BytePtr = (uint8*)Source;
	uint32	dDestination = (uint32)Destination;

	while(MaxBytes)
		{
		WriteMemory8((SimAddress)dDestination, (uint8)*BytePtr);
		if(!(*BytePtr))
			break;
		--MaxBytes;
		++BytePtr;
		++dDestination;
		}
	return ( true );
	}

bool
MemorySystem	::	CopyStringToHost(
	void	*Destination,
	void	*Source,
	int		MaxBytes)
	{
	uint8	*BytePtr = (uint8*)Source;
	uint8	*dBytePtr = (uint8*)Destination;
	uint8	Byte;

	while(MaxBytes)
		{
		Byte = ReadMemory8((SimAddress)BytePtr);
		(*dBytePtr) = Byte;
		if(!Byte)
			break;
		++dBytePtr;
		++BytePtr;
		--MaxBytes;
		}
	return ( true );
	}


