#	include	"Simulator.h"

int
Simulator	::	PrintError(
	char	*fmt_s,
	...)
	{
    va_list valist;
    char    s[1024];

    va_start(valist, fmt_s);
    vsprintf(s, fmt_s, valist);
    va_end(valist);

    printf("%s", s);
    return(0);
	}

bool
Simulator	::	PrintStatistics(
	int		Format,
	FILE	*fp)
	{
	PrintValue(Format, fp, "CycleCount", CycleCount);
	return(true);
	}

bool
Simulator	::	Simulate ()
	{
	Halted = false;
	int		Index = 0;
	CycleCount = 0;


	while(Processor::NumberOfActiveProcessors > 0)
		{
		Index = 0;

		while(Index<NumberOfComponents)
			{
			ComponentTiming[Index] = 
				ComponentList[Index]->SimulateOneClockCycle();

			if(ComponentTiming[Index]<0)
				{
				// forever remove this component since it doesn't
				// want a tick anymore
				memcpy(&ComponentTiming[Index],
					&ComponentTiming[Index+1],
					(NumberOfComponents-Index-1)*sizeof(int));
				memcpy(&ComponentList[Index],
					&ComponentList[Index+1],
					(NumberOfComponents-Index-1)*sizeof(Component*));
				--NumberOfComponents;
				continue;
				}
			++Index;
			}
		++CycleCount;
		if(!NumberOfComponents)
			return(true);
		}
	return ( true );
	}

Simulator	::	Simulator()
	{
	int	Index = 0;

	for(Index=0;Index<MaxComponent;Index++)
		{
		ComponentList[Index] = NULL;
		ComponentTiming[Index] = -1;
		}
	Halted = false;
	NumberOfComponents = 0;
	}

bool
Simulator	::	RegisterComponent(
	Component	*c)
	{
	if(NumberOfComponents >= MaxComponent)
		return(false);
	ComponentList[NumberOfComponents] = c;
	ComponentTiming[NumberOfComponents] = 1;
	++NumberOfComponents;
	}

