#	include	<stdio.h>
#	include	<stdarg.h>

#	include	"MPLib.h"

volatile	int		commence = 0;

int	ncpus = 1;
int	cliblock = 1;

int
MPprintf(
	char	*s,	
	...)
	{
	va_list	valist;
	int		res;

	down(&cliblock);

	va_start(valist, s);
	res=vprintf(s, valist);fflush(stdout);
	va_end(valist);

	up(&cliblock);
	return(res);
	}

int
MPfprintf(
	FILE	*fp,
	char	*s,
	...)
	{
	va_list	valist;
	int		res;

	down(&cliblock);

	va_start(valist, s);
	res = vfprintf(fp, s, valist);fflush(fp);
	va_end(valist);

	up(&cliblock);
	return(res);
	}

int
MPsprintf(
	char	*s,
	char	*s1,
	...)
	{
	va_list	valist;
	int		res;

	down(&cliblock);

	va_start(valist, s1);
	res = vsprintf(s, s1, valist);
	va_end(valist);

	up(&cliblock);
	return(res);
	}

#undef	fopen
FILE	*
MPfopen(
	char	*file,
	char	*mode)
	{
	FILE	*fp;
	down(&cliblock);
	fp = fopen(file, mode);
	up(&cliblock);
	return(fp);
	}

#undef	fclose
int
MPfclose(
	FILE	*fp)
	{
	int	res;
	down(&cliblock);
	res = fclose(fp);
	up(&cliblock);
	return(res);
	}

#undef	fgets
char	*
MPfgets(
	char	*s,
	int		l,
	FILE	*fp)
	{
	char	*	res;
	down(&cliblock);
	res = fgets(s,l,fp);
	up(&cliblock);
	return(res);
	}

#undef	fputs
int
MPfputs(
	char	*s,
	FILE	*fp)
	{
	int	res;
	down(&cliblock);
	res = fputs(s,fp);
	up(&cliblock);
	return(res);
	}

#undef	fgetc
int
MPfgetc(
	FILE	*fp)
	{
	int	res;
	down(&cliblock);
	res = fgetc(fp);
	up(&cliblock);
	return(res);
	}

#undef	fputc
int
MPfputc(
	int		c,
	FILE	*fp)
	{
	int	res;
	down(&cliblock);
	res = fputc(c, fp);
	up(&cliblock);
	return(res);
	}


int
up(
	spinlock	*semaphore)
	{
	return(fetchinc(semaphore));
	}

int
down(
	spinlock	*semaphore)
	{
	int	x, i, j;
	volatile	spinlock	*s1 = (volatile spinlock *) semaphore;

	while(1)
		{
		x = fetchdec(semaphore);
		if(x>0)
			break;	// got the luck
		fetchinc(semaphore);
		while((*s1)<1);	// pause all cpu's until one has a reasonable
						// chance of getting the lock.

		i = 0;			// now delay the cpu's in a skewed fashion
		j = (x*(-2));	// so that one that got here "first" gets the
		while(i<j)		// best chance of getting it again.  First is
			++i;		// sort of loosly defined here...
		}
	return(x);
	}

int
fetchinc(
	int	*counter)
	{
	int		Result, EResult;
	int		SysCallNumber = 2001;
	__asm__(	"lw $4, %2\n"
				"li $2, 2001\n"
				"syscall\n"
				"sw $2, %0\n"
				"sw $7, %1\n" : "=m" (Result), "=m" (EResult) :
					"m" (counter));
	return(Result);
	}

int
fetchdec(
	int	*counter)
	{
	int		Result, EResult;
	int		SysCallNumber = 2002;
	__asm__(	"lw $4, %2\n"
				"li $2, 2002\n"
				"syscall\n"
				"sw $2, %0\n"
				"sw $7, %1\n" : "=m" (Result), "=m" (EResult) :
					"m" (counter));
	return(Result);
	}

int
getcpu()
	{
	int		Result, EResult;
	int		SysCallNumber = 2000;

	__asm__(	"lw $2, %2\n"
				"syscall\n"
				"sw $2, %0\n"
				"sw $7, %1\n" : "=m" (Result), "=m" (EResult) :
					"m" (SysCallNumber));
	if((Result+1)>ncpus)
		ncpus = Result+1;
	return(Result);

	}

static	volatile	int	barrier_count = 0;

int
barrier()
	{
	fetchinc((int*)&barrier_count);
	while(barrier_count<ncpus)
		;
	if(getcpu()==0)
		barrier_count = 0;
	return(0);
	}

#undef	main

int
main(
	int		argc,
	char	*argv[],
	char	*argp[])
	{
	int	ret;

	commence = 1;
	ret = MPmain(argc, argv, argp);

	barrier();
	if(getcpu==0)	
		exit(ret);
	else
		{
		__asm__("	li $2, 1\n"
				"	syscall\n");
		}
	}

extern	int	_gp;

MPstart()
	{
	__asm__(	"la	$28, %0\n" : : "m" (_gp));
	if(getcpu()==0)
		__start();
	else
		{
		while(commence==0)
			;
		main(0, NULL, NULL);
		}
	exit(1);
	}

